// 专门写一些 在不同页面的公共方法
const util = require('./util')
const CryptoJS = require("./crypto-js.js");

// 列表页 的 公共 点击获取 广告详情
function getOfferAdDetails(id) {
    util.wxpost('/miniprogramApi/offer/ads/details', {
        id
    }).then(res => {
        if (res.code != 200) return
        let data = res.data
        if (!data.url) return
        let url = encodeURIComponent(data.url)
        wx.navigateTo({
            url: `/pages/webview/webview?url=${url}`,
        })
    })
}

// 公共跳转页面
function goPage(url) {
    wx.navigateTo({
        url,
        fail: function (err) {
            if (err.errMsg = "navigateTo:fail webview count limit exceed") {
                wx.redirectTo({
                    url,
                })
            }
        }
    })
}

// 
function toast(title) {
    wx.showToast({
        icon: "none",
        title,
    })
}

// isindex 是经过首页要更新一下
function xgBasicData(that, app, isindex = false) {
    return new Promise(resolve => {
        if (app.globalData.basicDataState && !isindex) {
            const basicData = app.globalData.basicData || {}
            resolve(basicData)
            return
        }

        util.wxget("/api/project.home/basicData").then(res => {
            if (res.code != 200) return
            const data = res.data
            const basicData = {
                contrastcount: data.contrastcount || 0,
                university: data.university,
                discipline: data.discipline,
                rankings: data.rankings,
                encodekey: data.encodekey,
            }

            resolve(basicData)

            app.globalData.basicData = basicData
            app.globalData.basicDataState = true
        })
    })
}

function formatNumberWithSpaces(number) {
    if (typeof number != 'string') number = ''
    return number.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
}

function decodeKey(encrypted, key) {
    return new Promise((resolve, reject) => {
        try {
            const app = getApp()
            var decodekey = app.globalData.basicData.encodekey
            const encryptedData = CryptoJS.enc.Base64.parse(encrypted)
            const decrypted = CryptoJS.AES.decrypt({
                ciphertext: encryptedData
            }, CryptoJS.enc.Utf8.parse(decodekey), {
                mode: CryptoJS.mode.ECB,
                padding: CryptoJS.pad.Pkcs7,
            })
            const text = JSON.parse(decrypted.toString(CryptoJS.enc.Utf8))
            resolve(text)
        } catch (error) {
            reject()
        }
    })
}

module.exports = {
    getOfferAdDetails,
    goPage,
    toast,
    xgBasicData,
    formatNumberWithSpaces,
    decodeKey,
}